#################################################
#
#  (C) 2017 Slávek Banko
#  slavek (DOT) banko (AT) axis.cz
#
#  Improvements and feedback are welcome
#
#  This file is released under GPL >= 2
#
#################################################

add_subdirectory( mcopclass )

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_BINARY_DIR}/arts/gui/common
  ${CMAKE_BINARY_DIR}/arts/midi
  ${CMAKE_BINARY_DIR}/arts/modules
  ${CMAKE_BINARY_DIR}/arts/runtime
  ${CMAKE_BINARY_DIR}
  ${ARTS_INCLUDE_DIRS}
  ${GLIB2_INCLUDE_DIRS}
  ${TQT_INCLUDE_DIRS}
  ${TDE_INCLUDE_DIR}
)

link_directories(
  ${TQT_LIBRARY_DIRS}
  ${ARTS_LIBRARY_DIRS}
)


##### artsmoudlessynth (library) ################

tde_add_library( artsmodulessynth SHARED
  SOURCES
    artsmodulessynth.cc
    synth_xfade_impl.cc synth_autopanner_impl.cc synth_delay_impl.cc
    synth_cdelay_impl.cc synth_envelope_adsr_impl.cc synth_pscale_impl.cc
    synth_tremolo_impl.cc synth_fx_cflanger_impl.cc synth_compressor_impl.cc
    synth_pitch_shift_impl.cc synth_pitch_shift_fft_impl.cc c_filter_stuff.c
    synth_shelve_cutoff_impl.cc synth_brickwall_limiter_impl.cc
    synth_std_equalizer_impl.cc synth_rc_impl.cc synth_moog_vcf_impl.cc
    synth_atan_saturate_impl.cc synth_fm_source_impl.cc
    synth_wave_tri_impl.cc synth_noise_impl.cc synth_wave_softsaw_impl.cc
    synth_wave_square_impl.cc synth_wave_pulse_impl.cc synth_osc_impl.cc
    synth_play_pat_impl.cc synth_capture_wav_impl.cc
    synth_midi_test_impl.cc synth_sequence_impl.cc synth_sequence_freq_impl.cc
    synth_midi_debug_impl.cc objectcache_impl.cc synth_nil_impl.cc
    synth_debug_impl.cc synth_data_impl.cc synth_div_impl.cc
  VERSION 0.0.0
  LINK
    artsbuilder-shared artsmidi_idl-shared
    mcop artsflow artsflow_idl artsgsl ${ARTS_LIBRARIES} ${GLIB2_LIBRARIES}
  DESTINATION ${LIB_INSTALL_DIR}
)

add_custom_command(
  OUTPUT
    artsmodulessynth.cc artsmodulessynth.h
    artsmodulessynth.mcopclass artsmodulessynth.mcoptype
  COMMAND ${ARTS_MCOPIDL_EXECUTABLE} -t
    -I${CMAKE_SOURCE_DIR}/arts/gui/common
    -I${CMAKE_SOURCE_DIR}/arts/midi
    -I${ARTS_INCLUDEDIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/artsmodulessynth.idl
  DEPENDS artsmodulessynth.idl
)


##### other data ################################

install(
  FILES
    artsmodulessynth.idl
    ${CMAKE_CURRENT_BINARY_DIR}/artsmodulessynth.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/arts
)

install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/artsmodulessynth.mcoptype
    ${CMAKE_CURRENT_BINARY_DIR}/artsmodulessynth.mcopclass
  DESTINATION ${LIB_INSTALL_DIR}/mcop
)
